unit UBigImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    MonoButton: TButton;
    ExitButton: TButton;
    MsgLabel: TLabel;
    Image1: TImage;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure MonoButtonClick(Sender: TObject);
    procedure Panel1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
      MsgLabel.Caption:='uvuJ[vNbNĉ';
end;

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
            Close;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
      MonoButton.SetFocus;
end;

procedure TForm1.MonoButtonClick(Sender: TObject);
const TL = 10000;
var  x0, y0, r, i : Longint;
     x1, y1, x2, y2 : Extended;
begin
    WindowState:=wsMaximized;
    UpDated;
    MonoButton.Enabled:=false;
    with Panel1 do
      begin
        Enabled:=false;
        Color:=clBtnFace;
        Font.Color:=clGray;
      end;
    MsgLabel.Caption:='`撆ł';
    UpDate;

   with Image1 do
     begin
       Width:=2000; Height:=2000;
     end;

   x0:=1000; y0:=1000; r:=990;
   with Image1.Canvas do
     begin
       Pen.Color:=clBlack;
       MoveTo(x0,y0-r);
       for i:=1 to TL do
         begin
             x1:=0.5*r*cos((i*2.0*100.0/TL+0.5)*pi);
             y1:=0.5*r*sin((i*2.0*100.0/TL+0.5)*pi);
             x2:=0.5*r*cos((-i*4.0*100.5/TL+0.5)*pi);
             y2:=0.5*r*sin((-i*4.0*100.5/TL+0.5)*pi);
             LineTo(x0+round(x1+x2),y0-Round(y1+y2));
         end;
     end;

   MonoButton.Enabled:=true;
   with Panel1 do
     begin
       Enabled:=true;
       Color:=clAqua;
       Font.Color:=clRed;
     end;
   MsgLabel.Caption:='`I';
end;



procedure TForm1.Panel1Click(Sender: TObject);
const TL = 10000;
var  x0, y0, r, i : Longint;
     x1, y1, x2, y2 : Extended;

  function ClValue( x : Extended ) : TColor;
    var ir, ig, ib : Longint;
        xr, xg, xb : Extended;

    function Max( a, b : Extended ) : Extended;
      begin
            if a > b then Max:=a else Max:=b;
      end;

    begin
        if x < 0.0 then begin
                     ir:=255; ig:=255;  ib:=255;
                   end else
        if x < 1.0 then begin
                     xr:=1-x;
                     xg:=x;
                     ir:=round(255*xr/Max(xr,xg));
                     ig:=round(255*xg/Max(xr,xg));
                     ib:=0;
                   end else
        if x < 2.0 then begin
                     ir:=0;
                     xg:=2-x;
                     xb:=x-1;
                     ig:=round(255*xg/Max(xg,xb));
                     ib:=round(255*xb/Max(xg,xb));
                   end else
        if x < 3.0 then begin
                     xr:=x-2;
                     ig:=0;
                     xb:=3-x;
                     ir:=round(255*xr/Max(xr,xb));
                     ib:=round(255*xb/Max(xr,xb));
                   end else
                     begin
                       ir:=255; ig:=255; ib:=255;
                     end;

        ClValue:=RGB(ir, ig, ib);
    end;   {   ClValue   }

begin
    WindowState:=wsMaximized;
    UpDate;
    MonoButton.Enabled:=false;
    with Panel1 do
      begin
        Enabled:=false;
        Color:=clBtnFace;
        Font.Color:=clGray;
      end;
    MsgLabel.Caption:='`撆ł';
    UpDate;

   with Image1 do
     begin
       Width:=2000; Height:=2000;
     end;

   x0:=1000; y0:=1000; r:=990;
   with Image1.Canvas do
     begin
       MoveTo(x0,y0-r);
       for i:=1 to TL do
         begin
             Pen.Color:=ClValue( (i mod 100)*3/100 );
             x1:=0.5*r*cos((i*2.0*100.0/TL+0.5)*pi);
             y1:=0.5*r*sin((i*2.0*100.0/TL+0.5)*pi);
             x2:=0.5*r*cos((-i*4.0*100.5/TL+0.5)*pi);
             y2:=0.5*r*sin((-i*4.0*100.5/TL+0.5)*pi);
             LineTo(x0+round(x1+x2),y0-Round(y1+y2));
         end;
     end;

   MonoButton.Enabled:=true;
   with Panel1 do
     begin
       Enabled:=true;
       Color:=clAqua;
       Font.Color:=clRed;
     end;
   MsgLabel.Caption:='`I';
end;

end.
