unit UDiaP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    OKButton: TButton;
    ExitButton: TButton;
    PrintButton: TButton;
    procedure OKButtonClick(Sender: TObject);
    procedure ExitButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure PrintButtonClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

uses
  Printers;

{$R *.DFM}

procedure TForm1.ExitButtonClick(Sender: TObject);
begin
                 Close;
end;

var stID : Longint = 0;

procedure TForm1.FormActivate(Sender: TObject);
begin
  if stID = 0 then
    begin
        stID:=1;
        Edit1.Text:='20';
        PrintButton.Enabled:=false;
    end;
end;


var   n, x0, y0 : Longint;
      r : Extended;

type  TTp = (Frm, Prntr);

procedure DrawPattern( C  : TCanvas;
                       pw : Longint;  //  Pen̕
                       ct : TTp );
  var
    i, i1, i2 : Longint;
    Coord     : array[1..1000] of
                  record  x, y : Longint  end;
  begin
      for i:=1 to n do
        begin
          with Coord[i] do
            begin
                x:=round(x0+r*cos(2*pi*i/n));
                y:=round(y0+r*sin(2*pi*i/n));
            end;
        end;
      with C do
        begin
          if ct = Frm  //  tH[Canvas𔒂œhׂ
            then
              begin
                Pen.Color:=clWhite;
                Brush.Color:=clWhite;
                Rectangle(0,0,Form1.ClientWidth,Form1.ClientHeight);
                Pen.Color:=clBlue;
              end
            else
              Pen.Color:=clBlack; //  Printer̂Ƃ͍
          Pen.Width:=pw;

          for i1:=1 to n do
            for i2:=1 to n do
              if i1 <> i2 then
                begin
                  with Coord[i1] do MoveTo(x,y);
                  with Coord[i2] do LineTo(x,y);
                end;
        end;
  end;

procedure TForm1.OKButtonClick(Sender: TObject);
begin
      WindowState:=wsMaximized;
      UpDate;
      Edit1.Visible   :=false;
      OKButton.Visible:=false;
      Label1.Visible  :=false;
      with ExitButton do
        begin
            Top:=0; Left:=0;
        end;
      with PrintButton do
        begin
            Top:=ExitButton.Height;
            Left:=0;
            Enabled:=true;
        end;
      UpDate;

      n :=StrToInt(Edit1.Text);
      x0:=ClientWidth div 2;
      y0:=ClientHeight div 2;
      r :=0.9*y0;

      DrawPattern( Canvas, 1, Frm );
end;

procedure TForm1.PrintButtonClick(Sender: TObject);
begin
      ExitButton.Enabled:=false;
      PrintButton.Enabled:=false;
      UpDate;

      with Printer do   //  v^ւ̕`
        begin
          BeginDoc;

          x0:=PageWidth div 2;
          y0:=PageHeight div 2;
          if y0 < x0 then r:=0.9*y0
                     else r:=0.9*x0;

          DrawPattern( Canvas, 1, Prntr );

          EndDoc;
        end;

      Close;
end;

end.
