unit USample;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


type
  TEl1 = class
             a1 : integer;
             procedure s1;
         end;

  TEl2 = Class
             a1 : integer;
             procedure s1;
         end;

  TParent = class
                a1 : integer;
                E1 : TEl1;
                E2 : TEl2;
                constructor Create;
                procedure Free;
                procedure s1;
            end;

constructor TParent.Create;
  begin
      inherited Create;
      a1:=9;

      E1:=TEl1.Create;
      E2:=TEl2.Create;
      E1.a1:=1;
      E2.a1:=2;
  end;

procedure TParent.Free;
  begin
      E1.Free;
      E2.Free;
      inherited Free;
  end;

procedure TEl1.s1;
  begin
      ShowMessage('I am TEl1 type'+
                  '   a1 = '+IntToStr(a1));
  end;

procedure TEl2.s1;
  begin
      ShowMessage('I am TEl2 type'+
                  '   a1 = '+IntToStr(a1));
  end;

procedure TParent.s1;
  begin
      ShowMessage('I am TParent type'+
                  '   a1 = '+IntTostr(a1));
  end;

procedure TForm1.Button1Click(Sender: TObject);
var Obj : TParent;
begin
    Obj:=TParent.Create;

    with Obj do
      begin
          E1.s1;
          E2.s1;
          s1;
      end;

    Obj.Free;
    Close;
end;




end.
